Index: LMDZ6/trunk/libf/phylmd/inlandsis/inlandsis.F
===================================================================
--- LMDZ6/trunk/libf/phylmd/inlandsis/inlandsis.F	(revision 3897)
+++ LMDZ6/trunk/libf/phylmd/inlandsis/inlandsis.F	(revision 3900)
@@ -1,3 +1,3 @@
-      subroutine INLANDSIS(SnoMod,BloMod,jjtime)
+      subroutine INLANDSIS(SnoMod,BloMod,jjtime,debut)
 
       USE dimphy
@@ -173,6 +173,11 @@
       USE VARySV
       USE VARtSV
-      USE surface_data, only: iflag_tsurf_inlandsis
-
+      USE surface_data, ONLY: is_ok_z0h_rn,
+     .                        is_ok_density_kotlyakov,
+     .                        prescribed_z0m_snow,
+     .                        iflag_z0m_snow,
+     .                        iflag_tsurf_inlandsis,
+     .                        iflag_temp_inlandsis,
+     .                        discret_xf, buf_sph_pol,buf_siz_pol      
 
       IMPLICIT NONE
@@ -180,4 +185,5 @@
       logical   SnoMod
       logical   BloMod
+      logical   debut
       integer   jjtime
 
@@ -213,10 +219,9 @@
       integer   IceMsk,IcIndx(klonv)          !      Ice / No      Ice Mask
       integer   SnoMsk                        ! Snow     / No Snow     Mask
-
       real      roSMin,roSMax,roSn_1,roSn_2,roSn_3   ! Fallen Snow Density (PAHAUT)
       real      Dendr1,Dendr2,Dendr3          ! Fallen Snow Dendric.(GIRAUD)
       real      Spher1,Spher2,Spher3,Spher4   ! Fallen Snow Spheric.(GIRAUD)
       real      Polair                        ! Polar  Snow Switch
-      real      PorSno,Por_BS,Salt_f,PorRef   !
+      real      PorSno,Salt_f,PorRef   !
 c #sw real      PorVol,rWater                 !
 c #sw real      rusNEW,rdzNEW,etaNEW          !
@@ -244,6 +249,6 @@
       real      Z0m_Sn,Z0m_90                 ! Snow  Surface Roughness Length
       real      SnoWat                        ! Snow Layer    Switch
-c #RN real      rstar,alors                   !
-c #RN real      rstar0,rstar1,rstar2          !
+      real      rstar,alors                   !
+      real      rstar0,rstar1,rstar2          !
       real      SameOK                        ! 1. => Same Type of Grains
       real      G1same                        ! Averaged G1,  same Grains
@@ -263,5 +268,4 @@
       real      Sph_av                        ! Averaged    Grain Spher.
       real      Den_av                        ! Averaged    Grain Dendr.
-      real      DendOK                        ! 1. => Average is  Dendr.
       real      G1diff                        ! Averaged G1, diff. Grains
       real      G2diff                        ! Averaged G2, diff. Grains
@@ -277,8 +281,30 @@
       real      tt_c,vv_c                     ! Critical param.
       real      tt_tmp,vv_tmp,vv_virt         ! Temporary variables
-      logical   density_kotlyakov             ! .true. if Kotlyakov 1961
       real      e_prad,e1pRad,A_Rad0,absg_V,absgnI,exdRad ! variables for SoSosv calculations
       real      zm1, zm2, coefslope                    ! variables for surface temperature extrapolation
-
+! for Aeolian erosion and blowing snow
+      integer   nit   ,iit
+      real      Fac                           ! Correc. factor for drift ratio
+      real      dusuth,signus
+      real      sss__F,sss__N
+      real      sss__K,sss__G
+      real      us_127,us_227,us_327,us_427,us_527
+      real      VVa_OK, usuth0
+      real      ssstar
+      real      SblPom
+      real      rCd10n                        ! Square root of drag coefficient
+      real      DendOK                        ! Dendricity Switch
+      real      SaltOK                        ! Saltation  Switch
+      real      MeltOK                        ! Saltation  Switch (Melting Snow)
+      real      SnowOK                        ! Pack Top   Switch
+      real      SaltM1,SaltM2,SaltMo,SaltMx   ! Saltation  Parameters
+      real      ShearX, ShearS                ! Arg. Max Shear Stress
+      real      Por_BS                        ! Snow Porosity
+      real      Salt_us                       ! New thresh.friction velocity u*t
+      real      Fac_Mo,ArguSi,FacRho          ! Numerical factors for u*t
+      real      SaltSI(klonv,0:nsno)          ! Snow Drift Index              !
+      real      MIN_Mo                        ! Minimum Mobility Fresh Fallen *
+      character*3    qsalt_param              ! Switch for saltation flux param.
+      character*3    usth_param               ! Switch for u*t param
 
 
@@ -287,6 +313,6 @@
 
       data      T__Min / 200.00/              ! Minimum realistic Temperature
-      data      TaPole / 263.15/              ! Maximum Polar     Temperature
-      data      roSMin /  30.  /              ! Minimum Snow  Density
+      data      TaPole / 268.15/              ! Maximum Polar Temperature (value from C. Agosta)
+      data      roSMin / 300.  /              ! Minimum Snow  Density
       data      roSMax / 400.  /              ! Max Fresh Snow Density
       data      tt_c   / -2.0  /              ! Critical Temp. (degC)
@@ -305,4 +331,5 @@
       data      EmiWat /   0.99999999/        ! Emissivity of a Water Area
       data      EmiSno /   0.99999999/        ! Emissivity of Snow
+
       
 !     DATA      Emissivities                  ! Pielke, 1984, pp. 383,409
@@ -321,4 +348,16 @@
       data      Z0_ICE/    0.0010/            ! Sea-Ice Z0 = 0.0010 m (Andreas)
 !                                             !    (Ice Station Weddel -- ISW)
+! for aerolian erosion
+      data      SblPom/ 1.27/   ! Lower Boundary Height Parameter
+C +                             ! for Suspension
+C +                             ! Pommeroy, Gray and Landine 1993,
+C +                             ! J. Hydrology, 144(8) p.169
+      data      nit   / 5   /   ! us(is0,uth) recursivity: Nb Iterations
+cc#AE data      qsalt_param/"bin"/ ! saltation part. conc. from Bintanja 2001 (p
+      data      qsalt_param/"pom"/ ! saltation part. conc. from Pomeroy and Gray
+cc#AE data      usth_param/"lis"/  ! u*t from Liston et al. 2007
+      data      usth_param/"gal"/  ! u*t from Gallee et al. 2001
+      data      SaltMx/-5.83e-2/
+
       vk2    =  vonKrm  *  vonKrm             ! Square of Von Karman Constant
 
@@ -352,30 +391,27 @@
 
 
-! Blowing Particles Threshold Friction velocity
-! =============================================
-
-c #AE       usthSV(ikl) =                     1.0e+2
-!          END DO
-!xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
-
-
-
-
-! Contribution of Snow to the Surface Snow Pack
-! =============================================
-
-      IF (SnoMod)                                                 THEN
-
-
- 
-C +--Blowing Snow
-C +  ------------
- 
-        IF (BloMod) then
-         if (klonv.eq.1) then
+
+
+
+      IF (SnoMod)                            THEN
+
+ 
+C +--Aeolian erosion and Blowing Snow
+C +==================================
+
+
+
+        DO ikl=1,knonv
+            usthSV(ikl) =                     1.0e+2
+        END DO
+
+
+        IF (BloMod) THEN
+ 
+        if (klonv.eq.1) then
           if(isnoSV(1).ge.2                   .and.
-     .       TsisSV(1,max(1,isnoSV(1)))<273.  .and.
-     .       ro__SV(1,max(1,isnoSV(1)))<500.  .and.
-     .       eta_SV(1,max(1,isnoSV(1)))<epsi) then
+     .         TsisSV(1,max(1,isnoSV(1)))<273.  .and.
+     .         ro__SV(1,max(1,isnoSV(1)))<500.  .and.
+     .         eta_SV(1,max(1,isnoSV(1)))<epsi) then
 C +                       **********
                      call SISVAT_BSn
@@ -384,11 +420,219 @@
                      call SISVAT_BSn
 C +                       **********
-         endif
-        ENDIF
- 
-
-
+        endif
+
+
+
+
+
+
+
+! Calculate threshold erosion velocity for next time step
+! Unlike in sisvat, computation is of threshold velocity made here (instead of sisvaesbl)
+! since we do not use sisvatesbl for the coupling with LMDZ
+
+C +--Computation of threshold friction velocity for snow erosion
+C --------------------------------------------------------------- 
+
+        rCd10n =  1. / 26.5 ! Vt / u*t = 26.5
+                     ! Budd et al. 1965, Antarct. Res. Series Fig.13
+                     ! ratio developped during assumed neutral conditions
+ 
+
+C +--Snow Properties
+C +  ~~~~~~~~~~~~~~~
+
+        DO ikl = 1,knonv
+
+          isn      =  isnoSV(ikl)
+
+
+ 
+          DendOK   =  max(zero,sign(unun,epsi-G1snSV(ikl,isn)  ))  !
+          SaltOK   =  min(1   , max(istdSV(2)-istoSV(ikl,isn),0))  !
+          MeltOK   =     (unun                                     !
+     .             -max(zero,sign(unun,TfSnow-epsi                 !
+     .             -TsisSV(ikl,isn)  )))                           ! Melting Snow
+     .             *  min(unun,DendOK                              !
+     .                  +(1.-DendOK)                               !
+     .                      *sign(unun,     G2snSV(ikl,isn)-1.0))  ! 1.0 for 1mm
+          SnowOK   =  min(1   , max(isnoSV(ikl)      +1 -isn ,0))  ! Snow Switch
+ 
+          G1snSV(ikl,isn) =      SnowOK *    G1snSV(ikl,isn)
+     .                  + (1.- SnowOK)*min(G1snSV(ikl,isn),G1_dSV)
+          G2snSV(ikl,isn) =      SnowOK *    G2snSV(ikl,isn)
+     .                  + (1.- SnowOK)*min(G2snSV(ikl,isn),G1_dSV)
+ 
+          SaltOK   =  min(unun, SaltOK + MeltOK) * SnowOK
+ 
+ 
+C +--Mobility Index (Guyomarc'h & Merindol 1997, Ann.Glaciol.)
+C +  ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+          SaltM1   = -0.750e-2 * G1snSV(ikl,isn)
+     .             -0.500e-2 * G2snSV(ikl,isn)+ 0.500e00 !dendritic case
+C +     CAUTION:  Guyomarc'h & Merindol Dendricity Sign is +
+C +     ^^^^^^^^                    MAR Dendricity Sign is -
+          SaltM2   = -0.833d-2 * G1snSV(ikl,isn)
+     .             -0.583d-2 * G2snSV(ikl,isn)+ 0.833d00 !non-dendritic case
+ 
+c       SaltMo   = (DendOK   * SaltM1 + (1.-DendOK) *     SaltM2       )
+          SaltMo   = 0.625 !SaltMo pour d=s=0.5
+ 
+!weighting SaltMo with surface snow density (Vionnet et al. 2012)
+cc#AE   FacRho   = 1.25 - 0.0042 * ro__SV(ikl,isn)
+cc#AE   SaltMo   = 0.34 * SaltMo + 0.66 * FacRho !needed for polar snow
+          MIN_Mo   =  0.
+c       SaltMo   =  max(SaltMo,MIN_Mo)
+c       SaltMo   =  SaltOK   * SaltMo + (1.-SaltOK) * min(SaltMo,SaltMx)
+c #TUNE SaltMo   =  SaltOK   * SaltMo - (1.-SaltOK) *     0.9500
+          SaltMo   =  max(SaltMo,epsi-unun)
+ 
+C +--Influence of Density on Threshold Shear Stress
+C +  ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+          Por_BS =  1. - 300. / ro_Ice
+          ShearS = Por_BS / (1.-Por_BS)
+C +...         SheaBS =  Arg(sqrt(shear = max shear stress in snow)):
+C +            shear  =  3.420d00 * exp(-(Por_BS      +Por_BS)
+C +  .                                  /(unun        -Por_BS))
+C +            SheaBS :  see de Montmollin         (1978),
+C +                      These Univ. Sci. Medic. Grenoble, Fig. 1 p. 124
+ 
+C +--Snow Drift Index (Guyomarc'h & Merindol 1997, Ann.Glaciol.)
+C +  ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+          ArguSi      =     -0.085 *us__SV(ikl)/rCd10n
+!V=u*/sqrt(CD) eqs 2 to 4 Gallee et al. 2001
+ 
+          SaltSI(ikl,isn) = -2.868 * exp(ArguSi) + 1 + SaltMo
+ 
+
+C +--Threshold Friction Velocity
+C +  ~~~~~~~~~~~~~~~~~~~~~~~~~~~
+          if(ro__SV(ikl,isn)>300.) then
+             Por_BS      =  1.000       - ro__SV(ikl,isn)     /ro_Ice
+          else
+             Por_BS      =  1.000  - 300. /ro_Ice
+          endif
+ 
+          ShearX =  Por_BS/max(epsi,1.-Por_BS)
+          Fac_Mo = exp(-ShearX+ShearS)
+C +     Gallee et al., 2001    eq 5, p5
+ 
+          if (usth_param .eq. "gal") then
+            Salt_us   =   (log(2.868) - log(1 + SaltMo)) * rCd10n/0.085
+            Salt_us   = Salt_us * Fac_Mo
+C +...  Salt_us   :  Extension of  Guyomarc'h & Merindol 1998 with
+C +...              de Montmollin (1978). Gallee et al. 2001
+          endif
+ 
+          if (usth_param .eq. "lis") then !Liston et al. 2007
+            if(ro__SV(ikl,isn)>300.) then
+              Salt_us   = 0.005*exp(0.013*ro__SV(ikl,isn))
+            else
+              Salt_us   = 0.01*exp(0.003*ro__SV(ikl,isn))
+            endif
+          endif
+ 
+          SnowOK   =  1 -min(1,iabs(isn-isnoSV(ikl))) !Switch new vs old snow
+ 
+          usthSV(ikl) =     SnowOK *   (Salt_us)
+     .                + (1.-SnowOK)*    usthSV(ikl)
+ 
+        END DO
+
+
+ 
+!  Feeback between blowing snow turbulent Scale  u* (commented here
+!  since ustar is an input variable (not in/out) of inlandsis)
+!  -----------------------------------------------------------------
+
+
+!           VVa_OK      =  max(0.000001,       VVaSBL(ikl))
+!           sss__N      =  vonkar      *       VVa_OK
+!           sss__F      = (sqrCm0(ikl) - psim_z + psim_0)
+!           usuth0      =  sss__N /sss__F                ! u* if NO Blow. Snow
+ 
+!           sss__G      =  0.27417     * gravit
+ 
+! !  ______________               _____
+! !  Newton-Raphson (! Iteration, BEGIN)
+! !  ~~~~~~~~~~~~~~               ~~~~~
+!           DO iit=1,nit
+!           sss__K      =  gravit      * r_Turb * A_Turb *za__SV(ikl)
+!      .                                     *rCDmSV(ikl)*rCDmSV(ikl)
+!      .                           /(1.+0.608*QaT_SV(ikl)-qsnoSV(ikl))
+!           us_127      =  exp(    SblPom *log(us__SV(ikl)))
+!           us_227      =  us_127         *    us__SV(ikl)
+!           us_327      =  us_227         *    us__SV(ikl)
+!           us_427      =  us_327         *    us__SV(ikl)
+!           us_527      =  us_427         *    us__SV(ikl)
+ 
+!           us__SV(ikl) =  us__SV(ikl)
+!      .    - (  us_527     *sss__F     /sss__N
+!      .      -  us_427
+!      .      -  us_227     *qsnoSV(ikl)*sss__K
+!      .      + (us__SV(ikl)*us__SV(ikl)-usthSV(ikl)*usthSV(ikl))/sss__G)
+!      .     /(  us_427*5.27*sss__F     /sss__N
+!      .      -  us_327*4.27
+!      .      -  us_127*2.27*qsnoSV(ikl)*sss__K
+!      .      +  us__SV(ikl)*2.0                                 /sss__G)
+ 
+!           us__SV(ikl)= min(us__SV(ikl),usuth0)
+!           us__SV(ikl)= max(us__SV(ikl),epsi  )
+!           rCDmSV(ikl)=     us__SV(ikl)/VVa_OK
+! ! #AE     sss__F     =     vonkar     /rCDmSV(ikl)
+!           ENDDO
+ 
+! !  ______________               ___
+! !  Newton-Raphson (! Iteration, END  )
+! !  ~~~~~~~~~~~~~~               ~~~
+ 
+!           us_127      =  exp(    SblPom *log(us__SV(ikl)))
+!           us_227      =  us_127         *    us__SV(ikl)
+ 
+! !  Momentum            Turbulent Scale  u*: 0-Limit in case of no Blow. Snow
+! !  ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+!           dusuth      =  us__SV(ikl) - usthSV(ikl)       ! u* - uth*
+!           signus      =  max(sign(unun,dusuth),zero)     ! 1 <=> u* - uth* > 0
+!           us__SV(ikl) =                                  !
+!      .                   us__SV(ikl)  *signus  +         ! u* (_BS)
+!      .                   usuth0                          ! u* (nBS)
+!      .                            *(1.-signus)           !        
+
+
+
+
+!  Blowing Snow        Turbulent Scale ss*
+!  ---------------------------------------
+ 
+        hSalSV(ikl) = 8.436e-2  * us__SV(ikl)**SblPom
+ 
+        if (qsalt_param .eq. "pom") then
+          qSalSV(ikl) = (us__SV(ikl)**2 - usthSV(ikl)**2) *signus
+     .               / (hSalSV(ikl) * gravit * us__SV(ikl) * 3.25)
+        endif
+ 
+        if (qsalt_param .eq. "bin") then
+          qSalSV(ikl) = (us__SV(ikl) * us__SV(ikl)
+     .                -usthSV(ikl) * usthSV(ikl))*signus
+     .                * 0.535 / (hSalSV(ikl) * gravit)
+        endif
+ 
+        qSalSV(ikl) = qSalSV(ikl)/rht_SV(ikl) ! conversion kg/m3 to kg/kg
+ 
+        ssstar      = rCDmSV(ikl) * (qsnoSV(ikl) - qSalSV(ikl))
+     .              * r_Turb !Bintanja 2000, BLM
+!r_Turb compensates for an overestim. of the blown snow part. fall velocity
+ 
+        uss_SV(ikl) = min(zero    , us__SV(ikl) *ssstar)
+        uss_SV(ikl) = max(-0.0001 , uss_SV(ikl))   
+
+
+
+
+        ENDIF   ! BloMod
+ 
+C + ------------------------------------------------------
 C +--Buffer Layer
-C +  ------------
+C +  -----------------------------------------------------
  
           DO ikl=1,knonv
@@ -414,9 +658,9 @@
 c #NP.         104. *sqrt( max( VV10SV(ikl)-6.0,0.0)))  ! Kotlyakov (1961)
  
-            density_kotlyakov = .true.
-c #AC       density_kotlyakov = .false.  !C.Agosta snow densisty as if BS is on b
+!          C.Agosta option for snow density, same as for BS i.e.
+!          is_ok_density_kotlyakov=.false.
 c #BS       density_kotlyakov = .false.  !C.Amory BS 2018
 C + ...     Fallen Snow Density, Adapted for Antarctica
-            if (density_kotlyakov) then
+            if (is_ok_density_kotlyakov) then
                 tt_tmp = TaT_SV(ikl)-TfSnow
                 !vv_tmp = VV10SV(ikl)
@@ -452,14 +696,15 @@
 !    ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
  
-c #BS       Bros_N      = frsno
-c #BS       ro_new      = ro__SV(ikl,max(1,isnoSV(ikl)))
-c #BS       ro_new      = max(Bros_N,min(roBdSV,ro_new))
-c #BS       Fac         = 1-((ro__SV(ikl,max(1,isnoSV(ikl)))
-c #BS.                     -roBdSV)/(500.-roBdSV))
-c #BS       Fac         = max(0.,min(1.,Fac))
-c #BS       dsnbSV(ikl) = Fac*dsnbSV(ikl)
-c #BS       Bros_N      = Bros_N     * (1.0-dsnbSV(ikl))
-c #BS.                  + ro_new     *      dsnbSV(ikl)
-
+         if (BloMod) then
+         Bros_N      = frsno
+         ro_new      = ro__SV(ikl,max(1,isnoSV(ikl)))
+         ro_new      = max(Bros_N,min(roBdSV,ro_new))
+         Fac         = 1-((ro__SV(ikl,max(1,isnoSV(ikl)))
+     .               -roBdSV)/(500.-roBdSV))
+         Fac         = max(0.,min(1.,Fac))
+         dsnbSV(ikl) = Fac*dsnbSV(ikl)
+         Bros_N      = Bros_N     * (1.0-dsnbSV(ikl))
+     .               + ro_new     *      dsnbSV(ikl)
+         endif
 
  
@@ -480,55 +725,60 @@
      .               max(Spher1*VV__SV(ikl)+Spher2,     !     Sphericity
      .                   Spher3                   ))    !
+! EV: now control buf_sph_pol and bug_siz_pol in physiq.def
             Buf_G1      = (1. - Polair) *   Buf_G1      ! Temperate Snow
-     .                        + Polair  *   G1_dSV      ! Polar     Snow
+     .                        + Polair  *   buf_sph_pol ! Polar Snow 
             Buf_G2      = (1. - Polair) *   Buf_G2      ! Temperate Snow
-     .                        + Polair  *   ADSdSV      ! Polar     Snow
+     .                        + Polair  *   buf_siz_pol ! Polar Snow
                 G1      =                   Buf_G1      ! NO  Blown Snow
                 G2      =                   Buf_G2      ! NO  Blown Snow
 
- 
+
+
+            IF (BloMod) THEN 
+
 !     S.1. Meme  Type  de Neige  / same Grain Type
 !          ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
-c #BS       SameOK  =  max(zero,
-c #BS.                     sign(unun,    Buf_G1             *G1_dSV
-c #BS.                                 - eps_21                    ))
-c #BS       G1same  = ((1.0-dsnbSV(ikl))*Buf_G1+dsnbSV(ikl) *G1_dSV)
-c #BS       G2same  = ((1.0-dsnbSV(ikl))*Buf_G2+dsnbSV(ikl) *ADSdSV)
+
+           SameOK  =  max(zero,
+     .         sign(unun,    Buf_G1             *G1_dSV
+     .                            - eps_21                    ))
+           G1same  = ((1.0-dsnbSV(ikl))*Buf_G1+dsnbSV(ikl) *G1_dSV)
+           G2same  = ((1.0-dsnbSV(ikl))*Buf_G2+dsnbSV(ikl) *ADSdSV)
 !           Blowing Snow Properties:                         G1_dSV, ADSdSV
  
 !     S.2. Types differents / differents Types
 !          ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
-c #BS       typ__1  =  max(zero,sign(unun,epsi-Buf_G1))   ! =1.=> Dendritic
-c #BS       zroNEW  =     typ__1  *(1.0-dsnbSV(ikl))      ! fract.Dendr.Lay.
-c #BS.              + (1.-typ__1) *     dsnbSV(ikl)       !
-c #BS       G1_NEW  =     typ__1  *Buf_G1                 ! G1 of Dendr.Lay.
-c #BS.              + (1.-typ__1) *G1_dSV                 !
-c #BS       G2_NEW  =     typ__1  *Buf_G2                 ! G2 of Dendr.Lay.
-c #BS.              + (1.-typ__1) *ADSdSV                 !
-c #BS       zroOLD  = (1.-typ__1) *(1.0-dsnbSV(ikl))      ! fract.Spher.Lay.
-c #BS.              +     typ__1  *     dsnbSV(ikl)       !
-c #BS       G1_OLD  = (1.-typ__1) *Buf_G1                 ! G1 of Spher.Lay.
-c #BS.              +     typ__1  *G1_dSV                 !
-c #BS       G2_OLD  = (1.-typ__1) *Buf_G2                 ! G2 of Spher.Lay.
-c #BS.              +     typ__1  *ADSdSV                 !
-c #BS       SizNEW  =    -G1_NEW  *DDcdSV/G1_dSV          ! Size  Dendr.Lay.
-c #BS.               +(1.+G1_NEW         /G1_dSV)         !
-c #BS.                  *(G2_NEW  *DScdSV/G1_dSV          !
-c #BS.               +(1.-G2_NEW         /G1_dSV)*DFcdSV) !
-c #BS       SphNEW  =     G2_NEW         /G1_dSV          ! Spher.Dendr.Lay.
-c #BS       SizOLD  =     G2_OLD                          ! Size  Spher.Lay.
-c #BS       SphOLD  =     G1_OLD         /G1_dSV          ! Spher.Spher.Lay.
-c #BS       Siz_av =     (zroNEW*SizNEW+zroOLD*SizOLD)    ! Averaged Size
-c #BS       Sph_av = min( zroNEW*SphNEW+zroOLD*SphOLD     !
-c #BS.                   ,  unun)                         ! Averaged Sphericity
-c #BS       Den_av = min((Siz_av -(    Sph_av *DScdSV     !
-c #BS.                            +(1.-Sph_av)*DFcdSV))   !
-c #BS.                 / (DDcdSV -(    Sph_av *DScdSV     !
-c #BS.                            +(1.-Sph_av)*DFcdSV))   !
-c #BS.                   ,  unun)                         !
-c #BS       DendOK  = max(zero,                           !
-c #BS.                    sign(unun,     Sph_av *DScdSV   ! Small   Grains
-c #BS.                              +(1.-Sph_av)*DFcdSV   ! Faceted Grains
-c #BS.                              -    Siz_av        )) !
+           typ__1  =  max(zero,sign(unun,epsi-Buf_G1))   ! =1.=> Dendritic
+           zroNEW  =     typ__1  *(1.0-dsnbSV(ikl))      ! fract.Dendr.Lay.
+     .            + (1.-typ__1) *     dsnbSV(ikl)       !
+           G1_NEW  =     typ__1  *Buf_G1                 ! G1 of Dendr.Lay.
+     .            + (1.-typ__1) *G1_dSV                 !
+           G2_NEW  =     typ__1  *Buf_G2                 ! G2 of Dendr.Lay.
+     .            + (1.-typ__1) *ADSdSV                 !
+           zroOLD  = (1.-typ__1) *(1.0-dsnbSV(ikl))      ! fract.Spher.Lay.
+     .            +     typ__1  *     dsnbSV(ikl)       !
+           G1_OLD  = (1.-typ__1) *Buf_G1                 ! G1 of Spher.Lay.
+     .            +     typ__1  *G1_dSV                 !
+           G2_OLD  = (1.-typ__1) *Buf_G2                 ! G2 of Spher.Lay.
+     .            +     typ__1  *ADSdSV                 !
+           SizNEW  =    -G1_NEW  *DDcdSV/G1_dSV          ! Size  Dendr.Lay.
+     .            +(1.+G1_NEW         /G1_dSV)          !
+     .                  *(G2_NEW  *DScdSV/G1_dSV        !
+     .            +(1.-G2_NEW         /G1_dSV)*DFcdSV)  !
+           SphNEW  =     G2_NEW         /G1_dSV          ! Spher.Dendr.Lay.
+           SizOLD  =     G2_OLD                          ! Size  Spher.Lay.
+           SphOLD  =     G1_OLD         /G1_dSV          ! Spher.Spher.Lay.
+           Siz_av  =     (zroNEW*SizNEW+zroOLD*SizOLD)   ! Averaged Size
+           Sph_av  = min( zroNEW*SphNEW+zroOLD*SphOLD    !
+     .                 ,  unun)                         ! Averaged Sphericity
+           Den_av  = min((Siz_av -(    Sph_av *DScdSV    !
+     .            +(1.-Sph_av)*DFcdSV))                 !
+     .            / (DDcdSV -(    Sph_av *DScdSV        !
+     .            +(1.-Sph_av)*DFcdSV))                 !
+     .                   ,  unun)                       !
+           DendOK  = max(zero,                           !
+     .                    sign(unun,     Sph_av *DScdSV   ! Small   Grains
+     .                              +(1.-Sph_av)*DFcdSV   ! Faceted Grains
+     .                              -    Siz_av        )) !
 C +...      REMARQUE: le  type moyen (dendritique ou non) depend
 C +         ^^^^^^^^  de la  comparaison avec le diametre optique
@@ -538,13 +788,14 @@
 C +                   of a recent snow    having zero dendricity
  
-c #BS       G1diff  =(   -DendOK *Den_av
-c #BS.               +(1.-DendOK)*Sph_av) *G1_dSV
-c #BS       G2diff  =     DendOK *Sph_av  *G1_dSV
-c #BS.               +(1.-DendOK)*Siz_av
-c #BS       G1      =     SameOK *G1same
-c #BS.               +(1.-SameOK)*G1diff
-c #BS       G2      =     SameOK *G2same
-c #BS.               +(1.-SameOK)*G2diff
- 
+           G1diff  =(   -DendOK *Den_av
+     .            +(1.-DendOK)*Sph_av) *G1_dSV
+           G2diff  =     DendOK *Sph_av  *G1_dSV
+     .            +(1.-DendOK)*Siz_av
+           G1      =     SameOK *G1same
+     .            +(1.-SameOK)*G1diff
+           G2      =     SameOK *G2same
+     .            +(1.-SameOK)*G2diff
+           ENDIF
+
 
  
@@ -634,5 +885,4 @@
      .                            /max(epsi,BrosSV(ikl))!& [m w.e.] -> [m]
  
-
  
           END DO
@@ -640,16 +890,24 @@
 
 
-! Snow Pack Discretization
-! ========================
-
-!            **********
+! Snow Pack Discretization(option XF in MAR)
+! ==========================================
+
+          
+      if (discret_xf.AND.klonv.eq.1) then
+
+       if(isnoSV(1).ge.1.or.NLaysv(1).ge.1) then
+C +          **********
+         call SISVAT_zSn
+C +          **********
+       endif
+      else
+C +          **********
         call SISVAT_zSn
-!            **********
-
-!            **********
+C +          **********
+      endif
+ 
+C +          **********
 ! #ve   call SISVAT_wEq('_zSn  ',0)
-!            **********
-
-
+C +          **********
 
 ! Add a new Snow Layer
@@ -664,5 +922,4 @@
             TsisSV(ikl,isn) = TsisSV(ikl,isn) * (1-NLaysv(ikl))
      .                  + min(TaT_SV(ikl),Tf_Sno) *NLaysv(ikl) 
-
             ro__SV(ikl,isn) = ro__SV(ikl,isn) * (1-NLaysv(ikl))
      .                      + Brossv(ikl)     *    NLaysv(ikl) 
@@ -699,5 +956,5 @@
 
 
-      END IF
+      END IF  ! SnoMod
 
 
@@ -740,5 +997,5 @@
 ! =============================
 !Etienne: as in inlandis we do not call vgopt, we need to define
-!the albedo  alb_SV and to calculate the
+!the albedo alb_SV and to calculate the
 !absorbed Solar Radiation by Surfac (Normaliz)[-] SoSosv
 
@@ -810,12 +1067,11 @@
 
 
-! Aerodynamic Resistance
-! ^^^^^^^^^^^^^^^^^^^^^^
-
-
-       DO ikl=1,knonv
-          ram_sv(ikl) = 1./(cdM_SV(ikl)*max(VV__SV(ikl),eps6))
-          rah_sv(ikl) = 1./(cdH_SV(ikl)*max(VV__SV(ikl),eps6))
-        END DO
+! Aerodynamic Resistance (calculated from drags given by LMDZ)
+! Commented because already calculated in surf_inlandsis_mod
+! ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
+!       DO ikl=1,knonv
+!          ram_sv(ikl) = 1./(cdM_SV(ikl)*max(VV__SV(ikl),eps6))
+!          rah_sv(ikl) = 1./(cdH_SV(ikl)*max(VV__SV(ikl),eps6))
+!        END DO
 
 
@@ -825,9 +1081,12 @@
 
 
-      if (iflag_tsurf_inlandsis .eq. 0) then
+      if (iflag_temp_inlandsis .eq. 0) then
 
        call SISVAT_TSo
 
       else
+        DO ikl=1,knonv
+        Tsf_SV(ikl)=Tsrfsv(ikl)
+        END DO
 
        call SISVAT_TS2
@@ -938,6 +1197,10 @@
 ! Surface Temperature
 ! ^^^^^^^^^^^^^^^^^^^^
-!           Tsrfsv(ikl) =TsisSV(ikl,isnoSV(ikl))
-
+
+          IF (iflag_tsurf_inlandsis .EQ. 0) THEN   
+
+            Tsrfsv(ikl) =TsisSV(ikl,isnoSV(ikl))
+
+          ELSE IF (iflag_tsurf_inlandsis .GT. 0) THEN
 ! Etienne: extrapolation from the two uppermost levels:
 
@@ -959,6 +1222,12 @@
 
 
-        END DO
-
+         ELSE !(default)
+
+           Tsrfsv(ikl) =TsisSV(ikl,isnoSV(ikl))
+
+         END IF
+
+
+         END DO
 
 ! Snow Pack Properties (sphericity, dendricity, size)
@@ -967,12 +1236,15 @@
       IF (SnoMod)                                                 THEN
 
-!            **********
+      if (discret_xf .AND. klonv.eq.1) then
+      if(isnoSV(1).ge.1) then
+C +          **********
+      call SISVAT_GSn
+C +          **********
+      endif
+      else
+C +          **********
         call SISVAT_GSn
-!            **********
-
-!            **********
-! #ve   call SISVAT_wEq('_GSn  ',0)
-!            **********
-
+C +          **********
+      endif
 
 
@@ -990,51 +1262,57 @@
 C +--Roughness Length for Momentum
 C +  -----------------------------
+
+! ETIENNE WARNING: changes have been made wrt original SISVAT
  
 C +--Land+Sea-Ice / Ice-free Sea Mask
 C +  ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
-        DO ikl=1,klonv
+        DO ikl=1,knonv
           IcIndx(ikl) = 0
         ENDDO
         DO isn=1,nsno
-        DO ikl=1,klonv
+        DO ikl=1,knonv
+
           IcIndx(ikl) = max(IcIndx(ikl),
-     .                      isn*max(0,
-     .                              sign(1,
-     .                                   int(ro__SV(ikl,isn)-900.))))
+     .                  isn*max(0,
+     .                  sign(1,
+     .                  int(ro__SV(ikl,isn)-900.))))
         ENDDO
         ENDDO
  
-        DO ikl=1,klonv
+        DO ikl=1,knonv
           LISmsk    =     1. ! in inlandsis, land only
           IceMsk    =     max(0,sign(1   ,IcIndx(ikl)-1)  )
           SnoMsk    = max(min(isnoSV(ikl)-iiceSV(ikl),1),0)
 
- 
-
-          Z0mLnd      =max( Z0_ICE    ,    5.e-5  )  ! Min set := Z0 on *
 
 C +--Z0 Smooth Regime over Snow (Andreas 1995, CRREL Report 95-16, p. 8)
 C +  ^^^^^^^^^^^^^^^^^^^^^^^^^^
           Z0m_nu =       5.e-5 ! z0s~(10-d)*exp(-vonkar/sqrt(1.1e-03))
- 
+
 C +--Z0 Saltat.Regime over Snow (Gallee  et al., 2001, BLM 99 (19) p.11)
 C +  ^^^^^^^^^^^^^^^^^^^^^^^^^^
+
           u2star =       us__SV(ikl) *us__SV(ikl)
           Z0mBSn =       u2star      *0.536e-3   -  61.8e-6
           Z0mBSn =   max(Z0mBS0      ,Z0mBSn)
- 
+
 C +--Z0 Smooth + Saltat. Regime
 C +  ^^^^^^^^^^^^^^^^^^^^^^^^^^
           Z0enSV(ikl) =  Z0m_nu
      .                +  Z0mBSn
- 
-C +--Rough   Snow Surface Roughness Length (Typical Value)
-C +  ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
-c #tz     Z0m_Sn =    0.250e-3 ! Andreas 1995, CRREL Report 95-16, fig.1&p.2
-                               ! z0r~(10-d)*exp(-vonkar/sqrt(1.5e-03))-5.e-5
-          Z0m_Sn =    2.000e-3 ! Calibration    of MAR
-c #TZ     Z0m_Sn =    1.000e-3 ! Exemple Tuning in RACMO
-c #TZ     Z0m_Sn =    0.500e-3 ! Exemple Tuning in MAR
- 
+
+        
+! Calculation of snow roughness length
+!=====================================
+          IF (iflag_z0m_snow .EQ. 0) THEN
+
+          Z0m_Sn=prescribed_z0m_snow
+
+          ELSE IF (iflag_z0m_snow .EQ. 1) THEN
+
+          Z0m_Sn=Z0enSV(ikl) 
+
+          ELSE IF (iflag_z0m_snow .EQ. 2) THEN                             
+
 C +--Rough   Snow Surface Roughness Length (Variable Sastrugi Height)
 C +  ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
@@ -1045,4 +1323,6 @@
 ! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 ! Z0=f(T) deduced from observations, Adelie Land, dec2012-dec2013
+
+          
           coefa = 0.1658 !0.1862 !Ant
           coefb = -50.3869 !-55.7718 !Ant
@@ -1055,4 +1335,5 @@
           coefc = log(z03/z02)/(ta3-ta2)
           coefd = log(z03)-coefc*ta3
+
           if (TaT_SV(ikl) .lt. ta1) then
             Z0_obs = z01
